<script lang="ts">
  import PhaseDescription from "./components/PhaseDescription.svelte";
  import Pile from "./components/Pile.svelte";
  import Player from "./components/Player.svelte";
  import Scoreboard from "./components/Scoreboard.svelte";

  import {
    createActionDispatcher,
    getSuitScorers,
    isPlayerActive,
  } from "./utils";

  const dispatch = createActionDispatcher();

  export let state: GameState;
  export let settings: GameSettings;

  const _ = settings;

  export let playerId: PlayerId | null;

  $: user = state.players.find((p) => p.id === playerId);

  $: playerCount = state.players.length;
  let sortedPlayers = state.players;
  $: {
    const idx = state.players.findIndex((p) => p.id === playerId);

    sortedPlayers =
      idx !== -1
        ? [...state.players.slice(idx), ...state.players.slice(0, idx)]
        : state.players;
  }

  function getPlayerStyle(idx: number, playerCount: number): string {
    const startAngle = -Math.PI / 2;
    const angleStep = -(2 * Math.PI) / playerCount;
    const angle = startAngle + angleStep * idx;

    const xRadius = 26;
    const yRadius = 24;

    const x = Math.cos(angle) * xRadius;
    const y = -Math.sin(angle) * yRadius;

    return `
      --player-translate-x: ${x.toFixed(2)}rem;
      --player-translate-y: ${y.toFixed(2)}rem;
    `;
  }

  function getDiscardPileRotation(idx: number, playerCount: number): string {
    const startAngle = 0;
    const angleStep = (2 * Math.PI) / playerCount;
    const angle = startAngle + angleStep * idx;

    return `${angle}rad`;
  }

  function getDiscardPileStyle(idx: number, playerCount: number): string {
    const startAngle = -Math.PI / 2;
    const angleStep = -(2 * Math.PI) / playerCount;
    const angle = startAngle + angleStep * idx;

    const radius = 6.3;

    const xSignum =
      Math.abs(Math.cos(angle)) < 0.01 ? 0 : Math.sign(Math.cos(angle));
    const x = xSignum * radius;
    const y = -Math.sin(angle) * radius;

    return `
      --discard-pile-translate-x: ${x.toFixed(2)}rem;
      --discard-pile-translate-y: ${y.toFixed(2)}rem;
    `;
  }

  $: suitScorers =
    (state.phase.kind === "Scoring" || state.phase.kind == "End") &&
    getSuitScorers(state.players);
</script>

<div class="draw-pile">
  <Pile
    facedown
    showCount
    cards={state.deck}
    clickable={isPlayerActive(state, user?.id) &&
      state.phase.kind === "Drawing"}
    on:click={() => dispatch({ kind: "Draw" })}
  />
</div>

{#each state.players as player (player.id)}
  {@const idx = sortedPlayers.findIndex((p) => p.id === player.id)}

  <div
    class="discard-pile"
    style={getDiscardPileStyle(idx, state.players.length)}
    style:--discard-pile-rotate={getDiscardPileRotation(idx, playerCount)}
  >
    <Pile
      cards={player.discarded}
      clickable={isPlayerActive(state, user?.id) &&
        state.phase.kind === "Drawing"}
      on:click={() => dispatch({ kind: "Draw", fromPlayer: player.id })}
    />
  </div>

  <div class="player" style={getPlayerStyle(idx, playerCount)}>
    <Player
      {state}
      {player}
      isUser={user?.id === player.id}
      isActive={isPlayerActive(state, player.id)}
      scoringSuits={suitScorers && suitScorers.byPlayer[player.id].suits}
      on:action
    />
  </div>
{/each}

<div class="phase-description">
  <PhaseDescription phase={state.phase} userId={user?.id} />
</div>

{#if state.phase.kind === "End"}
  <div class="scoreboard panel">
    <Scoreboard players={state.players} paths={state.phase.paths} />
  </div>
{/if}

<style lang="scss">
  .player {
    --player-translate-x: 0;
    --player-translate-y: 0;

    position: absolute;
    top: 50%;
    left: 50%;
    transition: transform 0.5s;
    transform: translate(-50%, -50%) translateX(var(--player-translate-x))
      translateY(var(--player-translate-y));
  }

  .draw-pile {
    font-size: 50%;
    top: 50%;
    left: 50%;
    position: absolute;
    transform: translate(-50%, -50%);
  }

  .discard-pile {
    font-size: 50%;
    position: absolute;
    top: 50%;
    left: 50%;
    transition: transform 0.5s;
    transform: translate(-50%, -50%) translateX(var(--discard-pile-translate-x))
      translateY(var(--discard-pile-translate-y));
  }

  .phase-description {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(11rem);
  }

  .scoreboard {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
</style>
